Attribute VB_Name = "JMRegisterSubs"
Option Explicit
    Global Const REG_SZ As Long = 1
    Global Const REG_DWORD As Long = 4
    Global Const HKEY_LOCAL_MACHINE = &H80000002
    Global Const ERROR_NONE = 0
    Global Const KEY_ALL_ACCESS = &H3F
    
    Declare Function GetProfileString Lib "kernel32" _
        Alias "GetProfileStringA" _
        (ByVal lpAppName As String, _
        ByVal lpKeyName As String, _
        ByVal lpDefault As String, _
        ByVal lpReturnedString As String, _
        ByVal nSize As Long) As Long
    
    Declare Function RegCloseKey Lib "advapi32.dll" _
        (ByVal hKey As Long) As Long

    Declare Function RegOpenKeyEx Lib "advapi32.dll" _
        Alias "RegOpenKeyExA" _
        (ByVal hKey As Long, _
        ByVal lpSubKey As String, _
        ByVal ulOptions As Long, _
        ByVal samDesired As Long, _
        phkResult As Long) As Long

    Declare Function RegQueryValueExString Lib "advapi32.dll" _
        Alias "RegQueryValueExA" _
        (ByVal hKey As Long, _
        ByVal lpValueName As String, _
        ByVal lpReserved As Long, _
        lpType As Long, _
        ByVal lpData As String, _
        lpcbData As Long) As Long

    Declare Function RegQueryValueExLong Lib "advapi32.dll" _
        Alias "RegQueryValueExA" _
        (ByVal hKey As Long, _
        ByVal lpValueName As String, _
        ByVal lpReserved As Long, _
        lpType As Long, _
        lpData As Long, _
        lpcbData As Long) As Long

    Declare Function RegQueryValueExNULL Lib "advapi32.dll" _
        Alias "RegQueryValueExA" _
        (ByVal hKey As Long, _
        ByVal lpValueName As String, _
        ByVal lpReserved As Long, _
        lpType As Long, _
        ByVal lpData As Long, _
        lpcbData As Long) As Long

Public Function JMGetRegString(argKeyValue As String) As String
    On Error Resume Next
    JMGetRegString = QueryValue(HKEY_LOCAL_MACHINE, _
        "SOFTWARE\Classes\" & argKeyValue, "")
End Function

Public Function QueryValue(sKeyArea As Long, sKeyName As String, _
        sValueName As String) As Variant
    Dim lRetVal As Long
    Dim hKey As Long
    Dim vValue As Variant
    lRetVal = RegOpenKeyEx(sKeyArea, sKeyName, 0, KEY_ALL_ACCESS, hKey)
    lRetVal = QueryValueEx(hKey, sValueName, vValue)
    If (lRetVal <> ERROR_NONE) Then vValue = ""
    RegCloseKey (hKey)
    QueryValue = vValue
End Function

Function QueryValueEx(ByVal lhKey As Long, ByVal szValueName As String, _
        vValue As Variant) As Long
    Dim cch As Long
    Dim lrc As Long
    Dim lType As Long
    Dim lValue As Long
    Dim sValue As String
    Dim StrLen As Integer
    On Error GoTo QueryValueExError
'
'  Determine the size and type of data to be read
    lrc = RegQueryValueExNULL(lhKey, szValueName, 0&, lType, 0&, cch)
    If (lrc <> ERROR_NONE) Then Error 5
    Select Case lType
'
'  For strings
    Case REG_SZ:
        sValue = String(cch, 0)
        lrc = RegQueryValueExString(lhKey, szValueName, 0&, lType, sValue, cch)
            If (lrc = ERROR_NONE) Then
                StrLen = lstrlen(sValue)
                vValue = Left$(sValue, StrLen)
            Else
                vValue = Empty
            End If
'
'  For DWORDS
    Case REG_DWORD:
        lrc = RegQueryValueExLong(lhKey, szValueName, 0&, lType, lValue, cch)
        If (lrc = ERROR_NONE) Then vValue = lValue
    Case Else
'
'  all other data types not supported
        lrc = -1
    End Select
'
'  Errors
QueryValueExExit:
    QueryValueEx = lrc
    Exit Function
QueryValueExError:
    Resume QueryValueExExit
End Function

Public Sub JMLoadProgram(ProExt As String, ProgramName As String, _
    ProgramCall As String)
'
'  This Routine actually gets the Program String associated
'  with a particular extension.
    Dim StrLen As Integer
    Dim OutBuffer As String
    Dim Work As String
    Dim Work2 As String
    Dim kk As Integer
    Dim pos As Integer
    Dim LocalFixedString As String * 200
'
'  Get Program Name associated with a particular extension
    On Error Resume Next
    ProgramName = ""
    ProgramCall = ""
    If (Left$(ProExt, 1) = ".") Then
        Work = ProExt
    Else
        Work = "." & ProExt
    End If
    OutBuffer = JMGetRegString(Work)
'
'  Fully Resolve using Registration Database
    If (OutBuffer <> "") Then
'
'  Store Program Name
        ProgramName = OutBuffer
        Work2 = JMGetRegString(OutBuffer)
        If (Work2 <> "") Then ProgramName = Work2
'
'  Loop until the shell is found
        Do
            Work = OutBuffer
            OutBuffer = JMGetRegString(Work & "\shell\open\command")
            If (OutBuffer <> "") Then
                ProgramCall = OutBuffer
                Exit Sub
            End If
            OutBuffer = JMGetRegString(Work)
            If (OutBuffer = "") Then Exit Sub
        Loop
'
'  Get from win.ini if not in Registration Database
    Else
        LocalFixedString = String(140, 32)
        StrLen = GetProfileString("Extensions", ProExt, "", _
            LocalFixedString, 128)
'
'  Change Program Call to Registration Database Format
        If (StrLen > 0) Then
            Work = Trim$(LCase$(Left$(LocalFixedString, StrLen)))
            pos = InStr(Work, "^." & LCase$(ProExt))
            If (pos <= 0) Then
                ProgramCall = Work
            Else
                ProgramCall = Left(Work, pos - 1) & "%1"
                pos = pos + 5
                If (pos <= Len(Work)) Then
                    ProgramCall = ProgramCall & Mid$(Work, pos)
                End If
            End If
        End If
    End If
End Sub

Function JMSetupProgramCall(argProgramCall As String, argFileName As String) As String
'
'  This Generates the Program Call for the Shell Program
'
'  A typical call used with Shell would be
'    flg = Shell(ZZSetupProgramCall(ZZNotePadCall, FilePath), 1)
'
'  FilePath is the full file path of the file to be edited by
'  the notepad.
    Dim wrkString As String
    Dim wrkPos As Integer
'
'  Setup call string with %1
    On Error Resume Next
    wrkString = argProgramCall
    wrkPos = InStr(argProgramCall, "%1")
    If (wrkPos > 0) Then
        If (wrkPos > 1) Then
            wrkString = Left$(argProgramCall, wrkPos - 1)
        Else
            wrkString = ""
        End If
        wrkString = wrkString & argFileName
        wrkPos = wrkPos + 2
        If (wrkPos <= Len(argProgramCall)) Then
            wrkString = wrkString & Mid$(argProgramCall, wrkPos)
        End If
'
'  No %1 in String
    Else
        wrkString = wrkString & " " & argFileName
    End If
    JMSetupProgramCall = wrkString
End Function

